    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.data;
    034
    035import java.io.Serializable;
    036
    037import org.jfree.chart3d.internal.Args;
    038import org.jfree.chart3d.internal.ObjectUtils;
    039
    040/**
    041 * A data item where a key is associated with a value (typically numerical).
    042 * <br><br>
    043 * NOTE: This class is serializable, but the serialization format is subject
    044 * to change in future releases and should not be relied upon for persisting
    045 * instances of this class.
    046 */
    047@SuppressWarnings("serial")
    048public final class DefaultKeyedValue<K extends Comparable<K>, T>
    049        implements KeyedValue<K, T>, Serializable {
    050
    051    /** The key. */
    052    private final K key;
    053
    054    /** The value. */
    055    private T value;
    056
    057    /**
    058     * Creates a new instance.
    059     *
    060     * @param key  the key ({@code null} not permitted).
    061     * @param value  the value.
    062     */
    063    public DefaultKeyedValue(K key, T value) {
    064        Args.nullNotPermitted(key, "key");
    065        this.key = key;
    066        this.value = value;
    067    }
    068
    069    /**
    070     * Returns the key.
    071     *
    072     * @return The key (never {@code null}).
    073     */
    074    @Override
    075    public K getKey() {
    076        return this.key;
    077    }
    078
    079    /**
    080     * Returns the value.
    081     *
    082     * @return The value (possibly {@code null}).
    083     */
    084    @Override
    085    public T getValue() {
    086        return this.value;
    087    }
    088
    089    /**
    090     * Sets the value.
    091     *
    092     * @param value  the value ({@code null} permitted).
    093     */
    094    public void setValue(T value) {
    095        this.value = value;
    096    }
    097
    098    /**
    099     * Tests this instance for equality with an arbitrary object.
    100     *
    101     * @param obj  the object to test ({@code null} permitted).
    102     *
    103     * @return A boolean.
    104     */
    105    @Override
    106    public boolean equals(Object obj) {
    107        if (obj == this) {
    108            return true;
    109        }
    110        if (!(obj instanceof DefaultKeyedValue)) {
    111            return false;
    112        }
    113        DefaultKeyedValue<?, ?> that = (DefaultKeyedValue<?, ?>) obj;
    114        if (!this.key.equals(that.key)) {
    115            return false;
    116        }
    117        if (!ObjectUtils.equals(this.value, that.value)) {
    118            return false;
    119        }
    120        return true;
    121    }
    122
    123    @Override
    124    public String toString() {
    125        return "(" + this.key.toString() + ", " + value + ")";
    126    }
    127}